library flamingo;

import 'package:cloud_firestore/cloud_firestore.dart'
    show DocumentReference, CollectionReference, Firestore;
import 'package:firebase_storage/firebase_storage.dart' show FirebaseStorage;

export 'package:cloud_firestore/cloud_firestore.dart';
export 'package:firebase_storage/firebase_storage.dart';

export 'package:flamingo/batch.dart';
export 'package:flamingo/distributed_counter.dart';
export 'package:flamingo/document.dart';
export 'package:flamingo/document_accessor.dart';
export 'package:flamingo/storage.dart';
export 'package:flamingo/run_transaction.dart';
export 'package:flamingo/helper/helper.dart';
export 'package:flamingo/master/master.dart';
export 'package:flamingo/model/collection.dart';
export 'package:flamingo/model/counter.dart';
export 'package:flamingo/model/storage_file.dart';
export 'package:flamingo/model/model.dart';
export 'package:flamingo/model/increment.dart';
export 'package:flamingo/enum/execute_type.dart';

class Flamingo {
  static Flamingo instance = Flamingo();
  static void configure({
    Firestore firestore,
    FirebaseStorage storage,
    DocumentReference root,
  }) {
    instance.firestore = firestore != null ? firestore : Firestore.instance;
    instance.firebaseStorage = storage != null ? storage : FirebaseStorage.instance;
    instance.rootReference = root != null ? root : instance.firestore.document('');
  }

  DocumentReference rootReference;
  Firestore firestore;
  FirebaseStorage firebaseStorage;
}

DocumentReference get rootReference => Flamingo.instance.rootReference;
Firestore get firestoreInstance => Flamingo.instance.firestore;
FirebaseStorage get storageInstance => Flamingo.instance.firebaseStorage;
CollectionReference collectionReference(String path) => Flamingo.instance.rootReference.collection(path);
